 /*
	Cross-platform WMP Calling Functions
	Copyright  2007-2008 Harry Whitfield
	
	Playlist Object and CD Functions
	Copyright 2007 Michael Tughan

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License as
	published by the Free Software Foundation; either version 2 of
	the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public
	License along with this program; if not, write to the Free
	Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
	MA  02110-1301  USA
	
	Cross-platform WMP Calling Functions version 2.9
	9 January, 2008
	Copyright  2007-2008 Harry Whitfield
	mailto:g6auc@arrl.net
	
	Playlist Object and CD Functions
	28 May, 2007
	Copyright 2007 Michael Tughan
	mailto: michaelsprogramming@ca.inter.net
*/

// To play Windows Media using QuickTime Player on the Macintosh, you must
// also install the free Flip4Mac WMV Player, available from Microsoft.
// http://www.microsoft.com/windows/windowsmedia/player/wmcomponents.mspx

//var resPath = "/Users/nhw/Desktop/WMP/";                    // for testing

var resPath = "Resources/";                                     // set an appropriate resPath

if (system.platform == 'windows') { include(resPath + 'winWMP.js'); } else { include(resPath + 'macWMP.js'); }

/*

Example calls

var wmpPlayer = new WMP();                                              // construct WMP player for use later
var wmpPlayer = new WMP("file:///Users/nhw/Movies/Ricky on Glass.mp4"); // construct WMP player to play local file
var wmpPlayer = new WMP("http://proxitv12.speednet.at/radioktn");       // construct WMP player to play remote file or stream

wmpPlayer.quit();                       // release the WMP player - it is important to use this call when done with the player

wmpPlayer.getURL();                  	// get the url of the movie or stream
wmpPlayer.setURL(url);                  // set or change the movie or stream
wmpPlayer.versionInfo();                // get the Windows Media Player or QuickTime Player version number
wmpPlayer.close();                      // close the current movie or stream
wmpPlayer.playState();                  // get the state of the player 0..11 (see list of constants)
wmpPlayer.mediaDuration();              // get the duration of the current item (in seconds)
wmpPlayer.mediaDurationString();        // get the duration of the current item (in [hh:]mm:ss)

wmpPlayer.controlAvailable(type);		// does control "type" exist?
wmpPlayer.pause();                      // pause the current movie or stream
wmpPlayer.playPause();                  // toggle between play and pause
wmpPlayer.stop();                       // stop the current movie or stream
wmpPlayer.fastForward();                // move to the end of the current movie
wmpPlayer.fastReverse();                // rewind to the beginning of the current movie
wmpPlayer.currentPosition();            // get playing time in seconds
wmpPlayer.setCurrentPosition(secs);     // set playing time in seconds
wmpPlayer.currentPositionString();      // get playing time in [hh:]mm:ss
wmpPlayer.getPlayerPosition();          // get playing time in [hh:]mm:ss

wmpPlayer.volume();                     // get the sound volume 0..100
wmpPlayer.setVolume(volume);            // set the sound volume 0..100
wmpPlayer.autoStart();                  // get the autoStart state (boolean)
wmpPlayer.setAutoStart(flag);           // set the autoStart state (boolean) - applies only to movies
wmpPlayer.mute();                       // get the muted state (boolean)
wmpPlayer.setMute(flag);                // set the muted state (boolean)

wmpPlayer.bitRate ();                   // get the data rate in kbps
wmpPlayer.downloadProgress();           // get download progress (percentage 0..100)

wmpPlayer.setMiniaturized(flag)			// hide or show the QuickTime Player window.

wmpPlayer.getCDs([character]);			// get an array containing CD indexes and descriptions, seperated by the defined character (| if not defined)
wmpPlayer.getCD(index);                 // get tracks from index CD (index from getCDs) (Playlist object)

*/

function Playlist(artist, album) {
	var songs = [], urls = [], count = 0;
	
	this.addItem = function(song, url) {
		songs[count] = song;
		urls[count] = url;
		count += 1;
	};
	
	this.getNumItems = function() { return count; };
	
	this.getItem = function(index) {
		return [
			songs[index],
			artist,
			album,
			urls[index]
		];
	};

	this.print = function() {
		var song;
		var n = this.getNumItems();
		for (var i = 0; i < n; i += 1) {
			song = this.getItem(i);
			eprint('Item[' + i + ']: ' + song[0] + ', ' + song[1] + ', ' + song[2] + ', ' + song[3]);
		}
	};
}

/*

Playlist Object from wmpPlayer.getCD();

Playlist.getNumItems();         // get the number of items in the playlist
Playlist.getItem(index);        // get an array containing the: song name, artist, album name, source url for use with WMP.setURL
Playlist.print();       	    // print the playlist

*/
