 /*
	Cross-platform RP Calling Functions - Macintosh Code
	Copyright © 2007-2008 Harry Whitfield

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License as
	published by the Free Software Foundation; either version 2 of
	the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public
	License along with this program; if not, write to the Free
	Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
	MA  02110-1301  USA
	
	Cross-platform RP Calling Functions version 2.4
	10 January, 2008
	Copyright © 2007-2008 Harry Whitfield
	mailto:g6auc@arrl.net
*/

function RP(url)	// Constructor of RP object
{
	this.URL = url;
	var script  = 'open clip with URL "' + this.URL + '"\n';
		script += 'get the number of players as string\n';
	this.player = Number(RP.doScript(script, 10, "0"));
}

RP.prototype.players = function () { return Number(RP.doScript('get the number of players as string\n', 2, "0")); };

RP.prototype.quit = function() { RP.doScript('quit\n', 2, ""); };

RP.doScript = function(script, timeout, defaultValue)
{
    var result = appleScript('tell application "RealPlayer"\n' + script + 'end tell\n', timeout);
    if (result.indexOf("AppleScript Error") >= 0) { sprint(script); lprint(result); return defaultValue; } return result;
};

// constants (not the same values as on Windows)

RP.rppsSeeking       =  0;	// Seeking
RP.rppsContacting    =  1;	// Contacting
RP.rppsLoading       =  2;	// Loading
RP.rppsStopped       =  3;	// Stopped
RP.rppsPlaying       =  4;	// Playing
RP.rppsPaused        =  5;	// Paused

RP.prototype.getURL = function() { return this.URL; };
RP.prototype.setURL = function(url)
{
	this.URL = url;
	this.stop();
	var script  = 'open clip with URL "' + this.URL + '"\n';
	script += 'get the number of players as string\n';
	this.player = Number(RP.doScript(script, 10, "0"));
};

RP.prototype.versionInfo = function() { return RP.doScript('get the version as string\n', 2, ""); };

RP.prototype.close = function() { RP.doScript('close window ' + this.player + '\n', 10, ""); };

RP.prototype.playState = function()
{
	function getState(data)	// «constant ****4STC»
	{
		var idx = data.indexOf("STC");
		return Number(data.substring(idx-1, idx));
	}
	return getState(RP.doScript('if not (exists player ' + this.player + ') then return "0STC"\nget the state of player ' + this.player + ' as string\n', 2, ""));
};


RP.prototype.play = function()  { RP.doScript('if not (exists player ' + this.player + ') then return\nplay player ' + this.player + '\n', 2, ""); };

RP.prototype.pause = function() { RP.doScript('if not (exists player ' + this.player + ') then return\npause player ' + this.player + '\n', 2, ""); };

RP.prototype.stop = function()  { RP.doScript('if not (exists player ' + this.player + ') then return\nstop player ' + this.player + '\n', 2, ""); };

RP.prototype.fastForward = function()
{
	var script  = 'if not (exists player ' + this.player + ') then return\n';
		script += 'set clip position of player ' + this.player + ' to clip length of player ' + this.player + '\n';
		RP.doScript(script, 2, "");
};

RP.prototype.fastReverse = function() { RP.doScript('if not (exists player ' + this.player + ') then return\nset clip position of player ' + this.player + ' to 0.0\n', 2, ""); };

RP.prototype.volume = function()
{ 
	var script  = 'set the current_volume to "0"\n';
		script += 'if (exists player ' + this.player + ') then set the current_volume to (the player volume of player ' + this.player + ') as string\n';
		script += 'get the current_volume\n';
	return Math.round(RP.doScript(script, 2, "0"));
};

RP.prototype.setVolume = function(volume)	// volume 0..100
{ 
	RP.doScript('if (exists player ' + this.player + ') then set the player volume of player ' + this.player + ' to ' + volume  + '\n', 2, "");
}; 

RP.prototype.mute = function()
{
	var script  = 'set the muted_state to "false"\n';
		script += 'if (exists player ' + this.player + ') then set the muted_state to (is muted of player ' + this.player + ') as string\n';
		script += 'get the muted_state\n';
	return RP.doScript(script, 2, "false") == "true";
};

RP.prototype.setMute = function(flag)
{
	var sFlag = "false"; if (flag) { sFlag = "true"; }
	RP.doScript('if (exists player ' + this.player + ') then set is muted of player ' + this.player + ' to ' + sFlag  + '\n', 2, "");
};

RP.prototype.bitRate = function()
{
	var script  = 'get encoded bitrate of player ' + this.player + ' as string\n';
	return Math.round( RP.doScript(script, 2, "0") / 1000);	// converted to kbps
};

RP.prototype.setMiniaturized = function(flag)
{
	var sFlag = "false"; if (flag) { sFlag = "true"; }
	RP.doScript('if (exists player ' + this.player + ') then set the miniaturized of window ' + this.player + ' to ' + sFlag  + '\n', 2, "");
};
