 /*
	Cross-platform RP Calling Functions - Windows Code
	Copyright © 2007-2008 Harry Whitfield

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License as
	published by the Free Software Foundation; either version 2 of
	the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public
	License along with this program; if not, write to the Free
	Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
	MA  02110-1301  USA
	
	Cross-platform RP Calling Functions version 2.4
	10 January, 2008
	Copyright © 2007-2008 Harry Whitfield
	mailto:g6auc@arrl.net
*/

function RP(url)	// Constructor of RP object
{
	this.URL = url;
	this.player = COM.createObject('rmocx.RealPlayer G2 Control');
	//COM.connectObject( this.player, "RealPlay" );
	this.player.SetSource(this.URL);
	this.player.SetAutoStart(true);
}

RP.prototype.players = function () { return 1; };

RP.prototype.quit = function()
{
	if (this.player.CanStop()) { this.player.DoStop(); }
	//COM.disconnectObject(this.player);
	this.player = null;
};

// constants (not the same values as on Macintosh)

RP.rppsStopped       =  0;	// Stopped
RP.rppsContacting    =  1;	// Contacting
RP.rppsLoading       =  2;	// Loading
RP.rppsPlaying       =  3;	// Playing
RP.rppsPaused        =  4;	// Paused
RP.rppsSeeking       =  5;	// Seeking

RP.prototype.getURL = function() { return this.URL; };
RP.prototype.setURL = function(url)
{
	this.URL = url;
	this.stop();
	this.player.SetSource(this.URL);
	this.play();
};

RP.prototype.versionInfo = function() { return this.player.GetVersionInfo(); };

RP.prototype.close = function()	// same as quit
{
	if (this.player.CanStop()) { this.player.DoStop(); }
	//COM.disconnectObject(this.player);
	this.player = null;
};

RP.prototype.playState = function() { return this.player.GetPlayState(); };

RP.prototype.play  = function() { if (this.player.CanPlay())  { this.player.DoPlay(); } };
RP.prototype.pause = function() { if (this.player.CanPause()) { this.player.DoPause(); } };
RP.prototype.stop  = function() { if (this.player.CanStop())  { this.player.DoStop(); } };

RP.prototype.fastForward = function()
{
	if (this.player.GetCanSeek()) { this.player.SetPosition(this.player.GetLength()); }
};

RP.prototype.fastReverse = function()
{ 
	if (this.player.GetCanSeek()) { this.player.SetPosition(0); }
};

RP.prototype.volume = function() { return this.player.GetVolume(); };

RP.prototype.setVolume = function(volume)	// volume 0..100
{ 
	this.player.SetVolume(volume);
}; 

RP.prototype.mute = function() { return this.player.GetMute(); };
RP.prototype.setMute = function(flag) { this.player.SetMute(flag); };

RP.prototype.bitRate = function() { return this.player.GetBandwidthAverage() / 1000; };		// converted to kbps

RP.prototype.setMiniaturized  = function(flag) { return; };		// dummy
