/*
	KonAVio Media - an Audio and Video Player Widget
	Copyright © 2008 John Riddle and Harry Whitfield

	This program is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the
	Free Software Foundation; either version 2 of the License, or (at your
	option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License along
	with this program; if not, write to the Free Software Foundation, Inc.,
	51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
	
	KonAVio Media - version 1.0b45
	2 March, 2008
	Copyright © 2008 John Riddle and Harry Whitfield
	mailto:g6auc@arrl.net
*/

var systemPlatform = system.platform;
//systemPlatform = 'windows';		// for testing Windows code on the Macintosh

eprint('KonAVio Media: Version 1.0b45');
eprint('systemPlatform: ' + systemPlatform);
eprint('system.widgetDataFolder: ' + system.widgetDataFolder);

//////////////////////////////////////// Code for Playlist Window ////////////////////////////////////////

include('Sources/playlist.js');

//////////////////////////////////////// Code for Information Window /////////////////////////////////////

function showInfoWindow(flag)
{
	iw.hOffset = screen.availLeft + screen.availWidth  - iw.width;
	iw.vOffset = screen.availTop  + screen.availHeight - iw.height;
	iw.visible   = flag;
	if (flag) { iwTimer.ticking = true; }
}

//////////////////////////////////////// Code for Player Window //////////////////////////////////////////

include('Sources/slider.js');

var playerAutoNext = false;

function playerClose()
{
	showInfoWindow(false);
	NowPlaying_text.data = "Stopped";
	quitAllMediaPlayers(); setPlayerPlayButton();
	if (!system.event.altKey) { pw.visible=false; }
	fw.visible=true;
	loadDataBase("SWF", gSWFIndex);
}

function playerPrev() 
{
	if ((wmpPlayer === null) && (rpPlayer === null ) && (qtPlayer === null)) { beep(); return; }

	var index = gXMLIndex, next, max;
	eprint('playerPrev');
	if (index === undefined) { index = -1; }
	loadDataBase("XML", index);
	max = dataBase.length; if (max === 0) { beep(); return; }
	next = index - 1; if (next < 0) { next = max - 1; }
	selectEntry(next);
	playEntry(next);
}

function playerNext()
{
	if ((wmpPlayer === null) && (rpPlayer === null ) && (qtPlayer === null)) { beep(); return; }

	playerAutoNext = system.event.altKey;
	var index = gXMLIndex, next, max;
	eprint('playerNext');
	if (index === undefined) { index = -1; }
	loadDataBase("XML", index);
	max = dataBase.length; if (max === 0) { beep(); return; }
	next = (index + 1) % max;
	selectEntry(next);
	playEntry(next);
}

//////////////////////////////////////// Player Window Volume Control ////////////////////////////////////

var volumeSlider  = null;

function setVolume()	// setVolume() is called whenever the volume slider is dragged
{
	var volume = Math.round(volumeSlider.getValue());
	setMediaPlayerVolume(volume);
	
	if ((volume === 0) && (!gVolumeMuted)) { playerMute(); } else if ((volume !== 0) && ( gVolumeMuted)) { playerUnmute(); }
}
															
volumeSlider = new Slider(pw, "Resources/Controls/volume_slider.png", "Resources/Controls/slider_knob.png", 75, 0, 100, 74, 125, setVolume);

var Slider_Knob = volumeSlider.sliderButton;

Slider_Knob.onMouseEnter = function () { Slider_Knob.src='Resources/Controls/slider_knob2.png'; };
Slider_Knob.onMouseExit  = function () { Slider_Knob.src='Resources/Controls/slider_knob.png';  };
Slider_Knob.tooltip = "Volume";

function playerMute()
{
	gVolumeMuted = true;
	setPlayerMutedButtons();
	setMediaPlayerMuted(true);
}

function playerUnmute()
{
	gVolumeMuted = false;
	setPlayerNotMutedButtons();
	setMediaPlayerMuted(false);
}

function setPlayerMutedButtons()
{
	PlayerVolumeLow.src          = "Resources/Controls/volume_mute_embedded.png";
	PlayerVolumeLow.tooltip      = "Restore Volume";
	PlayerVolumeLow.onMouseEnter = function () { PlayerVolumeLow.src='Resources/Controls/volume_low_embedded_blue.png'; };
	PlayerVolumeLow.onMouseExit  = function () { PlayerVolumeLow.src='Resources/Controls/volume_mute_embedded.png'; };
	PlayerVolumeLow.onMouseDown  = function () { PlayerVolumeLow.src='Resources/Controls/volume_low_embedded.png'; };
	PlayerVolumeLow.onMouseUp    = playerUnmute;
	
	PlayerVolumeHigh.src          = "Resources/Controls/volume_mute_embedded.png";
	PlayerVolumeHigh.tooltip      = "Restore Volume";
	PlayerVolumeHigh.onMouseEnter = function () { PlayerVolumeHigh.src='Resources/Controls/volume_hi_embedded_blue.png'; };
	PlayerVolumeHigh.onMouseExit  = function () { PlayerVolumeHigh.src='Resources/Controls/volume_mute_embedded.png'; };
	PlayerVolumeHigh.onMouseDown  = function () { PlayerVolumeHigh.src='Resources/Controls/volume_hi_embedded.png'; };
	PlayerVolumeHigh.onMouseUp    = playerUnmute;
}

function setPlayerNotMutedButtons()
{
	PlayerVolumeLow.src          = "Resources/Controls/volume_low_embedded.png";
	PlayerVolumeLow.tooltip      = "Mute Volume";
	PlayerVolumeLow.onMouseEnter = function () { PlayerVolumeLow.src='Resources/Controls/volume_mute_embedded_blue.png'; };
	PlayerVolumeLow.onMouseExit  = function () { PlayerVolumeLow.src='Resources/Controls/volume_low_embedded.png'; };
	PlayerVolumeLow.onMouseDown  = function () { PlayerVolumeLow.src='Resources/Controls/volume_mute_embedded.png'; };
	PlayerVolumeLow.onMouseUp    = playerMute;

	PlayerVolumeHigh.src          = "Resources/Controls/volume_hi_embedded.png";
	PlayerVolumeHigh.tooltip      = "Mute Volume";
	PlayerVolumeHigh.onMouseEnter = function () { PlayerVolumeHigh.src='Resources/Controls/volume_mute_embedded_blue.png'; };
	PlayerVolumeHigh.onMouseExit  = function () { PlayerVolumeHigh.src='Resources/Controls/volume_hi_embedded.png'; };
	PlayerVolumeHigh.onMouseDown  = function () { PlayerVolumeHigh.src='Resources/Controls/volume_mute_embedded.png'; };
	PlayerVolumeHigh.onMouseUp    = playerMute;
}

//////////////////////////////////////// Player Window Progress Bar //////////////////////////////////////

theTimer.ticking = true;

var oldPlayerState = undefined;

var progressBarWidth   = Progress_Slider.width - Progress_Indicator.width;
var progressBarHOffset = Progress_Slider.hOffset;

function setProgressBar(seconds)
{
	if (isNaN(seconds))  { seconds = 7; }
	if (seconds < 0)     { seconds = 8; }
	if (seconds > 86399) { seconds = 9; }
	
	var fraction = seconds / gMediaDuration;	// gMediaDuration should always be >= 0
	if (isNaN(fraction)) { fraction = 0.5; }
	if ((fraction < 0) || (fraction > 1)) { fraction = 0.5; }
	
	Progress_Indicator.hOffset = Math.round(fraction * progressBarWidth) +  progressBarHOffset;
	NowPlaying_text.data = WMP.formatTime(seconds) + "/" + gMediaDurationFormatted;
}

//////////////////////////////////////// Code for Player State ///////////////////////////////////////////

function logPlayerState(label)
{
	if (gMediaPaused != oldPlayerState) { lprint(label + ':isPlaying=' + (!gMediaPaused)); oldPlayerState = gMediaPaused; }
}

function updatePlayerState()	// called once a second by timer "theTimer"
{
	var state;
	if (wmpPlayer)
	{
		state = wmpPlayer.playState();
		gMediaPaused = (state != WMP.wmppsPlaying);
		if (gMediaPaused) { setPlayerPlayButton(); } else { setPlayerPauseButton(); }
		if (wmpPlayer.mute() && (!gVolumeMuted)) { playerMute(); } else
		if ((!wmpPlayer.mute()) && gVolumeMuted) { playerUnmute(); }
		setProgressBar(wmpPlayer.currentPosition());
		logPlayerState('timer');
		if ((state == WMP.wmppsMediaEnded) && playerAutoNext) { playerNext(); }
	}
	else if (rpPlayer)
	{
		state = rpPlayer.playState();
		gMediaPaused = (state != RP.rppsPlaying);
		if (gMediaPaused) { setPlayerPlayButton(); } else { setPlayerPauseButton(); }
		if (rpPlayer.mute() && (!gVolumeMuted)) { playerMute(); } else
		if ((!rpPlayer.mute()) && gVolumeMuted) { playerUnmute(); }
		Progress_Indicator.hOffset = Math.round(0.5 * progressBarWidth) +  progressBarHOffset;
		NowPlaying_text.data = "";
		logPlayerState('timer');
	}
	else if (qtPlayer)
	{
		state = qtPlayer.playState();
		gMediaPaused = (state != QT.qtPlaying);
		if (gMediaPaused) { setPlayerPlayButton(); } else { setPlayerPauseButton(); }
		if (qtPlayer.mute() && (!gVolumeMuted)) { playerMute(); } else
		if ((!qtPlayer.mute()) && gVolumeMuted) { playerUnmute(); }
		Progress_Indicator.hOffset = Math.round(0.5 * progressBarWidth) +  progressBarHOffset;
		NowPlaying_text.data = qtPlayer.getPlayerPosition();
		logPlayerState('timer');
	}
}

//////////////////////////////////////// Code for Play/Pause Buttons /////////////////////////////////////

function playerPlay()
{
	setMediaPlayerPaused(false);
	if (!gMediaPaused) { setPlayerPauseButton(); }
	logPlayerState('playerPlay');
}

function setPlayerPlayButton()
{
	PlayerPlay.src          = "Resources/Controls/play.png";
	PlayerPlay.tooltip      = "Play";
	PlayerPlay.onMouseEnter = function () { PlayerPlay.src='Resources/Controls/play_blue.png'; };
	PlayerPlay.onMouseExit  = function () { PlayerPlay.src='Resources/Controls/play.png'; };
	PlayerPlay.onMouseDown  = function () { PlayerPlay.src='Resources/Controls/play.png'; };
	PlayerPlay.onMouseUp    = playerPlay;
}

function playerStop()
{
	setMediaPlayerPaused(true);
	if (gMediaPaused) { setPlayerPlayButton(); }
	logPlayerState('playerStop');
}

function setPlayerPauseButton()
{
	PlayerPlay.src          = "Resources/Controls/pause.png";
	PlayerPlay.tooltip      = "Pause";
	PlayerPlay.onMouseEnter = function () { PlayerPlay.src='Resources/Controls/pause_blue.png'; };
	PlayerPlay.onMouseExit  = function () { PlayerPlay.src='Resources/Controls/pause.png'; };
	PlayerPlay.onMouseDown  = function () { PlayerPlay.src='Resources/Controls/pause.png'; };
	PlayerPlay.onMouseUp    = playerStop;
}

//////////////////////////////////////// Code for Flash Window ////////////////////////////////////////

//var theFlashURL  = "http://www.mea-culpa.com/swf/cd6.swf";
//var swfPlayer  = null;

var oldVideoState  = undefined;
var oldFlashLoaded = undefined;
var flashAutoNext  = false;

function frameClose()
{
	showInfoWindow(false);
	closeFlash();
	if (!system.event.altKey) { fw.visible=false; }
	pw.visible=true;
	loadDataBase("XML", gXMLIndex);
}

function framePrev()
{
	if (swfPlayer === null)  { beep(); return; }

	var index = gSWFIndex, next, max;
	eprint('framePrev');
	if (index === undefined) { index = -1; }
	loadDataBase("SWF", index);
	max = dataBase.length; if (max === 0) { beep(); return; }
	next = index - 1; if (next < 0) { next = max - 1; }
	selectEntry(next);
	playEntry(next);
}

function framePlay()  { playFlash(); }

function frameNext()
{
	if (swfPlayer === null)  { beep(); return; }

	var index = gSWFIndex, next, max;
	eprint('frameNext');
	if (index === undefined) { index = -1; }
	loadDataBase("SWF", index);
	max = dataBase.length; if (max === 0) { beep(); return; }
	next = (index + 1) % max;
	selectEntry(next);
	playEntry(next);
	flashAutoNext = system.event.altKey;
}

//////////////////////////////////////// Flash Window Volume Control /////////////////////////////////////

var systemVolumeSlider  = null;

function setSystemVolume()	// setSystemVolume() is called whenever the system volume slider is dragged
{
	var volume = Math.round(systemVolumeSlider.getValue());
	
	setFlashPlayerVolume(volume);
	
	if ((volume === 0) && (!gSystemVolumeMuted)) { frameMute(); } else if ((volume !== 0) && ( gSystemVolumeMuted)) { frameUnmute(); }
}
															
systemVolumeSlider = new Slider(fw, "Resources/Controls/volume_slider.png", "Resources/Controls/slider_knob.png", Math.round(6.25*system.volume), 0, 100, 189, 311, setSystemVolume);

var Frame_Slider_Knob = systemVolumeSlider.sliderButton;
var Frame_Slider_Base  = systemVolumeSlider.sliderBase;

Frame_Slider_Knob.onMouseEnter = function () { Frame_Slider_Knob.src='Resources/Controls/slider_knob2.png'; };
Frame_Slider_Knob.onMouseExit  = function () { Frame_Slider_Knob.src='Resources/Controls/slider_knob.png';  };
Frame_Slider_Knob.tooltip = "System Volume";

function frameMute()
{
	gSystemVolumeMuted = true;
	setFrameMutedButtons();
	setFlashPlayerMuted(true);
}

function frameUnmute()
{
	gSystemVolumeMuted = false;
	setFrameNotMutedButtons();
	setFlashPlayerMuted(false);
}

function setFrameMutedButtons()
{
	FrameVolumeLow.src          = "Resources/Controls/volume_mute_embedded.png";
	FrameVolumeLow.tooltip      = "Restore System Volume";
	FrameVolumeLow.onMouseEnter = function () { FrameVolumeLow.src='Resources/Controls/volume_low_embedded_blue.png'; };
	FrameVolumeLow.onMouseExit  = function () { FrameVolumeLow.src='Resources/Controls/volume_mute_embedded.png'; };
	FrameVolumeLow.onMouseDown  = function () { FrameVolumeLow.src='Resources/Controls/volume_low_embedded.png'; };
	FrameVolumeLow.onMouseUp    = frameUnmute;
	
	FrameVolumeHigh.src          = "Resources/Controls/volume_mute_embedded.png";
	FrameVolumeHigh.tooltip      = "Restore System Volume";
	FrameVolumeHigh.onMouseEnter = function () { FrameVolumeHigh.src='Resources/Controls/volume_hi_embedded_blue.png'; };
	FrameVolumeHigh.onMouseExit  = function () { FrameVolumeHigh.src='Resources/Controls/volume_mute_embedded.png'; };
	FrameVolumeHigh.onMouseDown  = function () { FrameVolumeHigh.src='Resources/Controls/volume_hi_embedded.png'; };
	FrameVolumeHigh.onMouseUp    = frameUnmute;
}

function setFrameNotMutedButtons()
{
	FrameVolumeLow.src          = "Resources/Controls/volume_low_embedded.png";
	FrameVolumeLow.tooltip      = "Mute System Volume";
	FrameVolumeLow.onMouseEnter = function () { FrameVolumeLow.src='Resources/Controls/volume_mute_embedded_blue.png'; };
	FrameVolumeLow.onMouseExit  = function () { FrameVolumeLow.src='Resources/Controls/volume_low_embedded.png'; };
	FrameVolumeLow.onMouseDown  = function () { FrameVolumeLow.src='Resources/Controls/volume_mute_embedded.png'; };
	FrameVolumeLow.onMouseUp    = frameMute;

	FrameVolumeHigh.src          = "Resources/Controls/volume_hi_embedded.png";
	FrameVolumeHigh.tooltip      = "Mute System Volume";
	FrameVolumeHigh.onMouseEnter = function () { FrameVolumeHigh.src='Resources/Controls/volume_mute_embedded_blue.png'; };
	FrameVolumeHigh.onMouseExit  = function () { FrameVolumeHigh.src='Resources/Controls/volume_hi_embedded.png'; };
	FrameVolumeHigh.onMouseDown  = function () { FrameVolumeHigh.src='Resources/Controls/volume_mute_embedded.png'; };
	FrameVolumeHigh.onMouseUp    = frameMute;
}

//////////////////////////////////////// Flash Window Resize Code ////////////////////////////////////////

function resize(x, y)
{
	var minW = 385, maxW = screen.availWidth  - 64, minH = 251, maxH = screen.availHeight - 96;
	if (x > maxW) { x = maxW; } if (x < minW) { x = minW; } if (y > maxH) { y = maxH; } if (y < minH) { y = minH; }
	fw.width  = x +  64; fw.height = y +  96;

	Frame_topMiddle.width      = Frame_bottomMiddle.width   = x;
	Frame_topRight.hOffset     = Frame_rightMiddle.hOffset  = Frame_bottomRight.hOffset  = x + 32;
	Frame_leftMiddle.height    = Frame_rightMiddle.height   = y;
	Frame_bottomLeft.vOffset   = Frame_bottomMiddle.vOffset = Frame_bottomRight.vOffset  = y + 32;

	FramePrevious.vOffset      = FramePlay.vOffset          = FrameNext.vOffset          = y + 52;
	FrameAdd.hOffset           = x +  5;
	FramePlaylist.hOffset      = x - 25;
	FrameFullScreen.hOffset    = x - 55;
	
	FrameAdd.vOffset           = FramePlaylist.vOffset      = FrameFullScreen.vOffset 	 = y + 52;
	Background.width           = x + 47;
	Background.height          = y + 19;
	FrameDragBox.hOffset = x + 42;
	FrameDragBox.vOffset = y + 70;
	
	Flash_text.hOffset = Math.round(0.5*fw.width - 95);
	
	FrameVolumeLow.vOffset     = FrameVolumeHigh.vOffset    = y + 52;
	Frame_Slider_Knob.vOffset  = y + 56;
	Frame_Slider_Base.vOffset   = y + 60;
	if (swfPlayer !== null) { swfPlayer.width = Background.width; swfPlayer.height = Background.height; }
}

function frameResize()
{
	var x = system.event.hOffset - 42, y = system.event.vOffset - 70;
	resize(x, y);
}

var fullScreenToggle = false;
var oldWindowHOffset = screen.availLeft;
var oldWindowVOffset = screen.availTop;

function fullScreen()
{
	fullScreenToggle = ! fullScreenToggle;
	if (fullScreenToggle)
	{
		oldWindowHOffset = fw.hOffset;
		oldWindowVOffset = fw.vOffset;
		fw.hOffset = screen.availLeft;
		fw.vOffset = screen.availTop;
		resize(screen.availWidth, screen.availHeight);
	}
	else
	{
		fw.hOffset = oldWindowHOffset;
		fw.vOffset = oldWindowVOffset;
		resize(0,0);
	}
}

function fs() { fullScreen(); }

function fadeFlashControls(opacity)
{
	var a = new FadeAnimation( FrameClose,			opacity, 350, animator.kEaseOut );
	var b = new FadeAnimation( FramePrevious,		opacity, 350, animator.kEaseOut );
	var c = new FadeAnimation( FramePlay,			opacity, 350, animator.kEaseOut );
	var d = new FadeAnimation( FrameNext,			opacity, 350, animator.kEaseOut );
	var e = new FadeAnimation( FrameVolumeLow,		opacity, 350, animator.kEaseOut );
	var f = new FadeAnimation( FrameVolumeHigh,		opacity, 350, animator.kEaseOut );
	var g = new FadeAnimation( FrameFullScreen,		opacity, 350, animator.kEaseOut );
	var h = new FadeAnimation( FramePlaylist,		opacity, 350, animator.kEaseOut );
	var i = new FadeAnimation( FrameAdd,			opacity, 350, animator.kEaseOut );
	var j = new FadeAnimation( FrameDragBox,		opacity, 350, animator.kEaseOut );
	var k = new FadeAnimation( Flash_text,			opacity, 350, animator.kEaseOut );
	var l = new FadeAnimation( Frame_Slider_Knob, 	opacity, 350, animator.kEaseOut );
	var m = new FadeAnimation( Frame_Slider_Base, 	opacity, 350, animator.kEaseOut );

	animator.start( [a, b, c, d, e, f, g, h, i, j, k, l, m] );
}

//////////////////////////////////////// Code for Flash State ////////////////////////////////////////////

function logFlashState(label)
{
	if (gFlashPaused != oldVideoState)  { lprint(label + ':isPlaying=' + (!gFlashPaused)); oldVideoState  = gFlashPaused; }
	if (gFlashLoaded != oldFlashLoaded)
	{
		lprint(label + ':%  Loaded=' + gFlashLoaded);
		Flash_text.data = 'Flash Loaded: ' + gFlashLoaded + '%';
		oldFlashLoaded = gFlashLoaded;
	}
}

function updateFlashState()	// called once a second by timer "theTimer"
{
	if (swfPlayer)
	{
		gFlashLoaded = swfPlayer.percentLoaded();
		gFlashPaused = ! swfPlayer.isPlaying();
		if (flvPlayerController)
		{
			if (!flvPlayerController.isPlaying()) { setFramePlayButton(); } else { setFramePauseButton(); }
		}
		else
		{
			if (gFlashPaused) { setFramePlayButton(); } else { setFramePauseButton(); }
		}
	}
	logFlashState('timer');
}

//////////////////////////////////////// Flash Player Code ///////////////////////////////////////////////

include("Sources/FLVPlayerController.js");	// FLV Player

var flvPlayerController = null;

function isLeopard()
{
   var result = "", leopard = 0x1050;	// Mac OS X 10.5 = 0x1050 = 4176
   if (systemPlatform == "macintosh")
   {
   		result = appleScript('get system attribute "sysv"\n', 2);	eprint('sysv: ' + result);
    	if (result.indexOf("AppleScript Error") >= 0)  { return false; }
		return Number(result) >= leopard;
    }
    return false;
}

var LEOPARD = isLeopard(); eprint('LEOPARD: ' + LEOPARD);

function openFlash(streamURL, volume, muted, paused, hidden)
{
	lprint('openFlash 1');
	
	if (streamURL.indexOf("file:///") === 0) { streamURL = streamURL.substring(8); }
	
	try
	{
		if (LEOPARD && (swfPlayer !== null)) { closeFlash(); }
		lprint('openFlash 2');
		if (swfPlayer === null) { swfPlayer = new Flash(fw); }
		lprint('openFlash 3');
    	swfPlayer.hOffset = 8;
    	swfPlayer.vOffset = 21;
    	swfPlayer.width   = Background.width;
    	swfPlayer.height  = Background.height;
    	swfPlayer.bgColor = "#4C4C4C";
		swfPlayer.allowNetworking = preferences.flashNetworkingPref.value;
		swfPlayer.useFlashContextMenu = (preferences.flashContextMenuPref.value == "1");
    	swfPlayer.loop = (preferences.flashLoopPref.value == "1");
		swfPlayer.quality = preferences.flashQualityPref.value;
		lprint('openFlash 4');
		if (xtn(streamURL) == ".flv")
		{
			swfPlayer.src = flvPlayer;
			lprint('openFlash 5');
			if ( ! LEOPARD ) { swfPlayer.reload(); }
			lprint('openFlash 6');
			swfPlayer.loadMovie(0, swfPlayer.src);
			lprint('openFlash 7');
			sleep(100);
			if (flvPlayerController === null) { flvPlayerController = new FLVPlayerController(swfPlayer); }
			lprint('openFlash 8');
			flvPlayerController.load(streamURL);
			lprint('openFlash 9');
		}
		else
		{
			flvPlayerController = null;
			lprint('openFlash 10');
			swfPlayer.src = streamURL;
			lprint('openFlash 11');
			if ( ! LEOPARD ) { swfPlayer.reload(); }
			lprint('openFlash 12');
			swfPlayer.loadMovie(0, swfPlayer.src);
			lprint('openFlash 13');
		}
		if (paused) { stopFlash(); } else { playFlash(); }
		lprint('openFlash 20');

//		Background.opacity = 0;
		Background.src = "Resources/Background/background.png";
	}
	catch (e) { lprint('openFlash:catch: ' + e); }
	
	lprint('openFlash 21');
}

function playFlash()
{
	if (swfPlayer === null) { beep(); return; }
	logFlashState('playFlash 1');
	if (flvPlayerController) { flvPlayerController.play(); } else { swfPlayer.play(); }
	setFramePauseButton();
	logFlashState('playFlash 2');
}

function setFramePlayButton()
{
	FramePlay.src          = "Resources/Controls/play_embedded.png";
	FramePlay.tooltip      = "Play";
	FramePlay.onMouseEnter = function () { FramePlay.src='Resources/Controls/play_embedded_blue.png'; };
	FramePlay.onMouseExit  = function () { FramePlay.src='Resources/Controls/play_embedded.png'; };
	FramePlay.onMouseDown  = function () { FramePlay.src='Resources/Controls/play_embedded.png'; };
	FramePlay.onMouseUp    = playFlash;
}

function stopFlash()
{
	if (swfPlayer === null) { beep(); return; }
	logFlashState('stopFlash 1');
	if (flvPlayerController) { flvPlayerController.pause(); } else { swfPlayer.stop(); }
	setFramePlayButton();
	logFlashState('stopFlash 2');
}

function setFramePauseButton()
{
	FramePlay.src          = "Resources/Controls/pause_embedded.png";
	FramePlay.tooltip      = "Pause";
	FramePlay.onMouseEnter = function () { FramePlay.src='Resources/Controls/pause_embedded_blue.png'; };
	FramePlay.onMouseExit  = function () { FramePlay.src='Resources/Controls/pause_embedded.png'; };
	FramePlay.onMouseDown  = function () { FramePlay.src='Resources/Controls/pause_embedded.png'; };
	FramePlay.onMouseUp    = stopFlash;
}

function closeFlash()		// type in debug window to test
{
	lprint('closeFlash 1');
	if (swfPlayer === null) { return; }
	lprint('closeFlash 2');
//	if (flvPlayerController) { delete flvPlayerController; }
	flvPlayerController = null;
	stopFlash();
	lprint('closeFlash 3');
	fw.removeChild(swfPlayer);
	lprint('closeFlash 4');
//	Background.opacity = 255;
	Background.src = "Resources/Background/background_title.png";
//	delete swfPlayer;
	swfPlayer = null;
	lprint('closeFlash 5');
	updateNow();
}

function quitFlash() { lprint('quitFlash 1'); closeFlash(); }

//////////////////////////////////////// Code for Media Players //////////////////////////////////////////

include('Sources/streams.js');

function makeDownloadFolder()
{
	if (filesystem.itemExists(system.widgetDataFolder + "/Downloads"))
	{
		filesystem.remove(system.widgetDataFolder + "/Downloads");
	}
	filesystem.createDirectory(system.widgetDataFolder + "/Downloads");
}

function deleteDownloads() { filesystem.remove(system.widgetDataFolder + "/Downloads"); }

makeDownloadFolder();

//var flvPlayer = widget.extractFile("flvPlayer.swf");
var flvPlayer = "flvPlayer.swf";

plw.onLoseFocus = function () { vsb.opacity =   0; selectionBar.opacity = 128; };
plw.onGainFocus = function () { vsb.opacity = 255; selectionBar.opacity = 255; };

fw.onLoseFocus = function () { fadeFlashControls(  0); };
fw.onGainFocus = function () { fadeFlashControls(255); };
