/*
	KonAVio Media - an Audio and Video Player Widget
	Copyright © 2008 John Riddle and Harry Whitfield

	This program is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the
	Free Software Foundation; either version 2 of the License, or (at your
	option) any later version.

	This program is distributed in the hope that it will be useful, but
	WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
	General Public License for more details.

	You should have received a copy of the GNU General Public License along
	with this program; if not, write to the Free Software Foundation, Inc.,
	51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
	
	KonAVio Media - version 1.0b45
	2 March, 2008
	Copyright © 2008 John Riddle and Harry Whitfield
	mailto:g6auc@arrl.net
*/

		var main_window = plw;

		var delWarning = true;			// delete warning preference flag

		var itemSep    = ' :: ';		// in database file - not allowed in keys
		var dataBase   = null;
		
		var gDataBase  = "XML";			// global to hold the selected database - set by readDataBase(db)

		var gSWFIndex   = undefined;	// global to hold the selected entry
		var gXMLIndex   = undefined;	// global to hold the selected entry

		var entryFrameHOffset  =  23;	// <!--frame name="entryFrame" hOffset="28" vOffset="0" width="376" height="104" />
		var entryFrameWidth    = 386;
		var nameDisplayWidth   = 136;
		var artistDisplayWidth = 128;
		var albumDisplayWidth  = 128;

    	var maxKeyLength  = 22;
    	
    	var entryFrame    = null;
    	var vDelta        =    2;		// tweak entry frame vertical position - macintosh value

    	if (system.platform == "windows") { vDelta = 2; }		// in case a different value is needed on Windows.

    	var entryDBHeight =   16;		// entry frame height
    	
    	var minEntries    =    7;
    	var maxEntries    =    7;
    	var minDBHeight   =    0;
    	var headDBHeight  =   45;
    	var midDBHeight   =   minEntries*entryDBHeight + headDBHeight + vDelta;
    	var maxDBHeight   =   screen.availHeight - 100;		// was maxEntries*entryDBHeight + headDBHeight + vDelta;

    	var theKeys    = null;			// to keep refs to the key (title) fields of the entry frames

		var theArtists = null;			// to keep refs to the artist fields of the entry frames
		var theAlbums  = null;			// to keep refs to the album fields of the entry frames
		
		var oldSelection = -1;			// last selected entry
		var lastEntry    = 0;
		
		var newKeyText = "Enter new key...";
		var saveBusy = false;			// to prevent more than one concurrent Save operations.

		var eoln = '\r\n'; if (system.platform == 'macintosh') { eoln = '\n'; }
		
		var lookFor1 = /<string>(.+?)<\/string>/;													// <string>http://tools.ietf.org/html/rfc1738</string>
		var lookFor2 = /URL\=(.+?)\n/i;																// need better reg exps
		var lookFor3 = /^(([^:\/\?\#]+):)?(\/\/([^\/\?\#]*))?([^\?\#]*)(\?([^\#]*))?(#(.*))?/;		// from RFC 3986
		
		function newFrame(window, hOffset, vOffset, width, height)
		{
			var frm = new Frame(window);
			frm.hOffset=hOffset;
			frm.vOffset=vOffset;
			frm.width=width;
			frm.height=height;
			return frm;
		}

		function newTextArea(hOffset, vOffset, width, height, scrollbar, editable, font, size, color, opacity )
		{
			var ta = new TextArea();
			ta.hOffset=hOffset;
			ta.vOffset=vOffset;
			ta.width=width;
			ta.height=height;
			ta.scrollbar=scrollbar;
			ta.editable=editable;
			ta.font=font;
			ta.size=size;
			ta.color=color;
			ta.opacity=opacity;
			return ta;
		}
		
		function newText(hOffset, vOffset, width, height, anchorStyle, font, size, color, opacity )
		{
			var tx = new Text();
			tx.hOffset=hOffset;
			tx.vOffset=vOffset;
			tx.width=width;
			tx.height=height;
			tx.anchorStyle=anchorStyle;
			tx.font=font;
			tx.size=size;
			tx.color=color;
			tx.opacity=opacity;
			return tx;
		}

		function newEntry(i, keyText, linkText, artistText, albumText, categoryText, modeText)
		{
			var entry   = newFrame(main_window, 0, entryDBHeight*i+vDelta, entryFrameWidth, entryDBHeight);
			entryFrame.appendChild( entry );
			var key     = newTextArea(0,   0, nameDisplayWidth, entryDBHeight, false, false, "Lucida Grande, Calibri, Tahoma", 11, "#FFFFFF", 255);
			var artist  = newText(nameDisplayWidth, 0, artistDisplayWidth, entryDBHeight, "topLeft", "Lucida Grande, Calibri, Tahoma", 11, "#FFFFFF", 255);
			var album   = newText(nameDisplayWidth+artistDisplayWidth, 0, albumDisplayWidth, entryDBHeight, "topLeft", "Lucida Grande, Calibri, Tahoma", 11, "#FFFFFF", 255);

			theKeys[i]    = key;
			theArtists[i] = artist;
			
			theAlbums[i]  = album;
			
			key.index    =
			artist.index =
			album.index  = i;
			
			key.data    = keyText;
			artist.data = artistText;
			album.data  = albumText;
			
			entry.tooltip = linkText + "\n" + modeText;
			
			key.onClick    =
			artist.onClick =
			album.onClick  = selectTheEntry;
			
			key.onMultiClick    = playTitle;
			artist.onMultiClick =
			album.onMultiClick  = playLink;
			
			key.onKeyPress    = keyPressEntry;

			entry.contextMenuItems = [];
			var m = 0;
			entry.contextMenuItems[m] = new MenuItem();
			entry.contextMenuItems[m].title = "Edit Entry...";
			entry.contextMenuItems[m].onSelect = editEntry;
			entry.contextMenuItems[m].index = i;
			m += 1;
			entry.contextMenuItems[m] = new MenuItem();
			entry.contextMenuItems[m].title = "Edit Title...";
			entry.contextMenuItems[m].onSelect = editTitle;
			entry.contextMenuItems[m].index = i;
			m += 1;
			entry.contextMenuItems[m] = new MenuItem();
			entry.contextMenuItems[m].title = "Remove Entry...";
			entry.contextMenuItems[m].onSelect = deleteEntry;
			entry.contextMenuItems[m].index = i;
			m += 1;
			entry.contextMenuItems[m] = new MenuItem();
			entry.contextMenuItems[m].title = "Replace Entry...";
			entry.contextMenuItems[m].onSelect = editLink;
			entry.contextMenuItems[m].index = i;
			m += 1;
			entry.contextMenuItems[m] = new MenuItem();
			entry.contextMenuItems[m].title = "-";
			
			entry.appendChild( key );
			entry.appendChild( artist );
			entry.appendChild( album );
		}

		function getDatabasePath(db)
		{
			switch(db)
			{
				case "SWF": return system.widgetDataFolder + '/SWFdatabase.xml';
				case "XML": return system.widgetDataFolder + '/XMLdatabase.xml';
			}
		}

		function getDeletedPath(db)
		{
			switch(db)
			{
				case "SWF": return system.widgetDataFolder + '/SWFdeleted.xml';
				case "XML": return system.widgetDataFolder + '/XMLdeleted.xml';
			}
		}
		
		/*
		<item>
		<link>file:////Users/nhw/Music/iot_20071004-1100.mp3</link>
		<title>IOT: Antimatter</title>
		<artist>BBC Radio 4</artist>
		<album>In Our Time With Melvyn Bragg</album>
		<category>Podcast</category>
		<mode>Automatic</mode>
		</item>
		*/

		function readDict(path)	// returns an array of objects or []
		{
    		var text = filesystem.readFile(path);
			if (text === null) { return []; }

    		var i, dom, items, link, title, artist, album, category, mode;
    		var dict = [];

			try { dom = XMLDOM.parse( text ); } catch (e) { eprint('readDict:XMLDOM.parse error: ' + e); return []; }
        	items = dom.evaluate( "rss/channel/item" );
        	if (items !== null) {
        		//eprint('readDict:There are ' + items.length + ' items.');
            	for (i = 0; i < items.length; i += 1) {
                	link     = items.item( i ).evaluate( "string( link )" );
                	title    = items.item( i ).evaluate( "string( title )" );
               	 	artist   = items.item( i ).evaluate( "string( artist )" );
                	album    = items.item( i ).evaluate( "string( album )" );
                	category = items.item( i ).evaluate( "string( category )" );
                	mode     = items.item( i ).evaluate( "string( mode )" );

                	dict[i]   = {};
                	dict[i].link     = link;
					dict[i].title    = title;
					dict[i].artist   = artist;
					dict[i].album    = album;
                	dict[i].category = category;
                	dict[i].mode     = mode;
            	}
            	return dict;
        	}
        	return [];
		}
		
		function byTitle(a, b)	// order by title
		{
			if (a.title < b.title) { return -1; }
			if (a.title > b.title) { return  1; }
			return 0;
		}
		
		function byArtistThenTitle(a, b)	// order by artist and then by title
		{
			if (a.artist < b.artist) { return -1; }
			if (a.artist > b.artist) { return  1; }
			if (a.title  < b.title)  { return -1; }
			if (a.title  > b.title)  { return  1; }
			return 0;
		}
		
		function byAlbumThenTitle(a, b)	// order by album and then by title
		{
			if (a.album < b.album)   { return -1; }
			if (a.album > b.album)   { return  1; }
			if (a.title  < b.title)  { return -1; }
			if (a.title  > b.title)  { return  1; }
			return 0;
		}
		
		function sortByTitle()	// sort dataBase by title, then 
		{
			var key = "";	
			if (oldSelection >= 0) { key = dataBase[oldSelection].title; }
			dataBase = dataBase.sort(byTitle);
			writeDataBase(true);
			if (key !== "") { selectEntry(findIndexOfKey(key)); }
		}
		
		function sortByArtist()
		{
			var key = "";	
			if (oldSelection >= 0) { key = dataBase[oldSelection].title; }
			dataBase = dataBase.sort(byArtistThenTitle);
			writeDataBase(true);
			if (key !== "") { selectEntry(findIndexOfKey(key)); }
		}
		
		function sortByAlbum()
		{
			var key = "";	
			if (oldSelection >= 0) { key = dataBase[oldSelection].title; }
			dataBase = dataBase.sort(byAlbumThenTitle);
			writeDataBase(true);
 			if (key !== "") { selectEntry(findIndexOfKey(key)); }
		}

		function readDataBase(db)	// returns an array of objects or []
		{
			gDataBase = db;
			var path = getDatabasePath(db);
			return readDict(path);
		}

		function writeDict(path, dict)
		{
			function esc(s) { if (s.indexOf("&") < 0) { return s; } return '<![CDATA[' + s + ']]>'; }

			var head = '<?xml version="1.0" encoding="UTF-8"?>\n<rss version="2.0">\n<channel>\n';
			var tail = '</channel>\n</rss>\n';
			var body = "", entry;
			for (var i = 0; i < dict.length; i += 1)
			{
				entry = dict[i];
				body += '<item>\n';
				body += '<link>'     + esc(entry.link)     + '</link>\n';
				body += '<title>'    + esc(entry.title)    + '</title>\n';
				body += '<artist>'   + esc(entry.artist)   + '</artist>\n';
				body += '<album>'    + esc(entry.album)    + '</album>\n';
				body += '<category>' + esc(entry.category) + '</category>\n';
				body += '<mode>'     + esc(entry.mode)     + '</mode>\n';
				body += '</item>\n';
			}
			if (dict.length === 0) { filesystem.writeFile(path, ""); } else { filesystem.writeFile(path, head + body + tail); }
		}

		function writeDataBase(reload)
		{
			var path = getDatabasePath(gDataBase);
			writeDict(path, dataBase);
			if (reload) { refreshDisplay(); }
		}
		
		function writeEntry(path, entry)
		{
			function esc(s) { if (s.indexOf("&") < 0) { return s; } return '<![CDATA[' + s + ']]>'; }

			var body = "";
				body += '<item>\n';
				body += '<link>'     + esc(entry.link)     + '</link>\n';
				body += '<title>'    + esc(entry.title)    + '</title>\n';
				body += '<artist>'   + esc(entry.artist)   + '</artist>\n';
				body += '<album>'    + esc(entry.album)    + '</album>\n';
				body += '<category>' + esc(entry.category) + '</category>\n';
				body += '<mode>'     + esc(entry.mode)     + '</mode>\n';
				body += '</item>\n';
			filesystem.writeFile(path, body, true);
		}

		function appendDeleted(entry)
		{
			var path    = getDeletedPath(gDataBase);
			writeEntry(path, entry);
		}

		function makeDisplay(dataBase)		// constructs the entryFrame and populates it with data from the database
		{
			if (entryFrame !== null)
			{
				frm.removeChild( entryFrame ); entryFrame = null;
				theKeys    = null;
				theArtists = null;
				theAlbums = null;
			}
			entryFrame = newFrame(main_window, entryFrameHOffset, 0, entryFrameWidth, frm.height);	// <frame name="entryFrame" hOffset="23" vOffset="0" width="392" height="104">
			theKeys    = [];
			theArtists = [];
			theAlbums = [];
			frm.appendChild( entryFrame );
     		var i, item;
   			if (dataBase.length !== 0) { maxEntries = dataBase.length; } else { maxEntries = minEntries; }
   			if (maxEntries < minEntries) { maxEntries = minEntries; }
			var dbHeight = frm.height;
   			if (dataBase.length !== 0)
   			{
    			dbHeight = minEntries*entryDBHeight;
    			if (entryDBHeight*dataBase.length > dbHeight) { dbHeight = entryDBHeight*dataBase.length; }

    			lastEntry = dataBase.length - 1;
    			entryFrame.height = dbHeight;
    			for (i = 0; i < dataBase.length; i += 1)
    			{
    				item = dataBase[i];		// .split(itemSep);
      				newEntry(i, item.title, item.link, item.artist, item.album, item.category, item.mode);
    			}
    			selectEntry(oldSelection);
    		}
			else { entryFrame.height = minEntries*entryDBHeight; }
		}

		function refreshDisplay()
		{
			makeDisplay(dataBase);
		}

		function makeSpaceForEntry()	// called from newPLSTEntry()
		{
			maxEntries += 1;
   			if (maxEntries < minEntries) { maxEntries = minEntries; }
			var dbHeight = frm.height;
    		if (entryDBHeight*maxEntries > dbHeight) { dbHeight = entryDBHeight*maxEntries; }
			entryFrame.height = dbHeight;
		}

		function findIndexOfKey(key)
		{
			var item;
			for (var i = 0; i < dataBase.length; i += 1)
			{
				item = dataBase[i];
				if (item.title == key) { return i; }
			}
			return -1;
		}

		function findIndexOfLink(link)
		{
			var item;
			for (var i = 0; i < dataBase.length; i += 1)
			{
				item = dataBase[i];
				if (item.link == link) { return i; }
			}
			return -1;
		}
		
		function stripLeadingAndTrailingSpaces(s)
		{
			var lookFor = /^(\s*)(.*?)(\s*)$/;
			var found = s.match(lookFor);
			if (found !== null) { return found[2]; }
			return "";
		}

		function execForm(formDef, formTitle, formButtonOK, formButtonCancel)
		{
			var formFields = [];
			for (var i = 0; i < formDef.length ; i += 1)
			{
				formFields[i] = new FormField();
				formFields[i].name 		   = formDef[i][0];
				formFields[i].title 	   = formDef[i][1];
				formFields[i].type 		   = formDef[i][2];
				formFields[i].option 	   = formDef[i][3];
				formFields[i].defaultValue = formDef[i][4];
				formFields[i].description  = formDef[i][5];
			}
			var formResults = form(formFields, formTitle, formButtonOK, formButtonCancel);
			for (i = 0; i < formDef.length ; i += 1)
			{
				delete formFields[i];
				formFields[i] = null;
			}
			return formResults;
		}
		
		function importForm(title, link, artist, album, category, mode)	// full form for manual entry of all playlist items
		{
			var modes = ["Automatic", "-", "QuickTime Player", "RealPlayer", "Windows Media Player", "Application or Browser"];
		
			var modeDescription = 'You may choose the player to be used, or leave the Widget to choose one itself.';
			
			var formDef = [ ['title',    'Title:',    'text',  [''],  title,   'Enter the title (key) to be associated with this item.'],
							['link',     'Location:', 'text',  [''],  link,    'Enter the url or path for this item.'],
							['artist',   'Artist:',   'text',  [''],  artist,  'Enter the artist.'],
							['album',    'Album:',    'text',  [''],  album,   'Enter the album.'],
							['category', 'Category:', 'text',  [''],  category,'Enter the category (genre).'],
							['mode',     'Mode:',     'popup', modes, mode,     modeDescription] ];
		
			var formResults = execForm(formDef, 'Create or Edit Playlist Entry', 'Save', 'Cancel');
			
			var result = "";
			
			if (formResults !== null)
			{
				title    = formResults[0];
				link     = formResults[1];
				artist   = formResults[2];
				album    = formResults[3];
				category = formResults[4];
				mode     = formResults[5];
				
				
				result = link + itemSep + title  + itemSep + artist  + itemSep + album  + itemSep + category  + itemSep + mode;
			}
			return result;
		}
		
		function wrongPlaylist(link)
		{
			if (gDataBase == "SWF")
			{
				if ((xtn(link).toLowerCase() != ".swf") && (xtn(link).toLowerCase() != ".flv"))
				{
					beep(); alert('Please use the correct playlist.'); return true;
				}
			}
			else
			{
				if ((xtn(link).toLowerCase() == ".swf") || (xtn(link).toLowerCase() == ".flv"))
				{
					beep(); alert('Please use the correct playlist.'); return true;
				}
			}
			return false;
		}
		

		function importPLST()		// uses full form for manual entry of all playlist items
		{
			if (saveBusy) { beep(); alert('Please complete the current Save operation.'); return; }
			var entry = importForm("Enter new key...", "Enter the link or file path...", "artist", "album", "category", "Automatic");
			if (entry === "") { return; }	// user cancelled form
			var item = entry.split(itemSep);
			var link     = stripLeadingAndTrailingSpaces(item[0]); link = makeFileURL(link);
			var key      = stripLeadingAndTrailingSpaces(item[1]);
			var artist   = stripLeadingAndTrailingSpaces(item[2]);
			var album    = stripLeadingAndTrailingSpaces(item[3]);
			var category = stripLeadingAndTrailingSpaces(item[4]);
			var mode     = stripLeadingAndTrailingSpaces(item[5]);
			if (!isStream(link)) { beep(); alert('Invalid url: ' + link); return; }
			if (wrongPlaylist(link)) { return; }
			if ( (key === "") || (key.length > maxKeyLength) ) { beep(); alert('The key is too long or too short.'); return; }
			var idx = findIndexOfKey(key);
			if (idx >= 0) { beep(); alert('Key "' + key + '" is already in the database.'); return; }
			idx = -1;
			idx = findIndexOfLink(link);
			if (idx >= 0) { beep(); alert('Location "' + link + '" is already in the database.'); return; }
			saveBusy = true;
			var i = theKeys.length;
			if (i >= minEntries) { makeSpaceForEntry(); }
     		newEntry(i, key, link, artist, album, category, mode);
			entry = {};
			entry.link      = link;
			entry.title     = key;
			entry.artist    = artist;
			entry.album     = album;
			entry.category  = category;
			entry.mode  	= mode;
			dataBase.push(entry);
			selectEntry(i);
			if (i >= minEntries) { frm.end(); }
			writeDataBase(true);
			eprint('importPLST:Saved:    ' + entry.link + itemSep + entry.title);
			saveBusy = false;
		}

		function exportPLSTs()
		{
			var path = chooseFolder();
			eprint('exportPLSTs:path:    ' + path);
			if (path)
			{
				eprint('exportPLSTs:SWFdatabase:copy: ' + filesystem.copy(system.widgetDataFolder + '/SWFdatabase.xml', path));
				eprint('exportPLSTs:SWFdeleted: copy: ' + filesystem.copy(system.widgetDataFolder + '/SWFdeleted.xml',  path));
				eprint('exportPLSTs:XMLdatabase:copy: ' + filesystem.copy(system.widgetDataFolder + '/XMLdatabase.xml', path));
				eprint('exportPLSTs:XMLdeleted: copy: ' + filesystem.copy(system.widgetDataFolder + '/XMLdeleted.xml',  path));
			}
		}

		function selectTheEntry() { selectEntry(this.index); }

		function selectEntry(i)	// called when entry frames are clicked, -1 to deselect all entries
		{
			selectionBar.visible = (i >= 0);

			if (i >= 0)
			{
				selectionBar.vOffset = textFieldBG.vOffset = entryDBHeight*i;
			}
			else { textFieldBG.visible = false; }
			
			if (theKeys !== null)
			{
				if ((oldSelection >= 0) && theKeys[oldSelection])
				{
					theKeys[oldSelection].select(-1, -1);
					theKeys[oldSelection].editable = false;
					revertKey(oldSelection);
					textFieldBG.visible = false;
					theKeys[oldSelection].color     =
					theArtists[oldSelection].color  =
					theAlbums[oldSelection].color   = "#FFFFFF";
				}
				if ((i >= 0) && theKeys[i])
				{
					theKeys[i].color    =
					theArtists[i].color =
					theAlbums[i].color  = "#000000";
				}
			}
			oldSelection = i;
			updateNow();
		}

		function bgMouseDown()
		{
			var i = this.index;
			theKeys[i].select(-1, -1); theKeys[i].editable = false; replaceEntry(i); textFieldBG.visible = false;
		}

		function unlockEntry(i)	// called to make key field editable
		{
			if (oldSelection != i) { selectEntry(i); }
			theKeys[i].editable = true;
			theKeys[i].focus();
			theKeys[i].select(0, -1);
			textFieldBG.visible = true;

			// Make frame clickable so clicking on it commits the change.
			background_image.index = i;
			background_image.onMouseDown = bgMouseDown;
		}

		function keyPressEntry()	// called during key entry
		{
			var i = this.index;
			if ((system.event.keyString == "Return") || (system.event.keyString == "Enter"))
  			{
  				theKeys[i].rejectKeyPress();
  				theKeys[i].select(-1, -1);
				theKeys[i].editable = false;
 				replaceEntry(i);
  			}
  			else if (system.event.keyString == "Tab") { beep( ); theKeys[i].rejectKeyPress(); }	// ignore tabs
  			else if (system.event.keyString == "Escape") { theKeys[i].select(-1, -1); theKeys[ i ].editable = false; revertKey( i ); }	// Reset old data.
		}

		function revertKey(i)
		{
			theKeys[i].data = dataBase[i].title;
			textFieldBG.visible = false;
		}

		function replaceEntry(i)	// the user has typed a new key in the key field
		{
			// Take away click action.
			background_image.onMouseDown = function() { };
			textFieldBG.visible = false;

			var key = theKeys[i].data;
			key = stripLeadingAndTrailingSpaces(key);
			if ( (key === "") || (key.indexOf(itemSep) >= 0) || (key.length > maxKeyLength) )
			{ revertKey(i); beep(); alert('The new key was too long or otherwise invalid.'); unlockEntry(i); return; }
			var idx = findIndexOfKey(key);
			if (idx == i) { revertKey(i); if (key == newKeyText) { unlockEntry(i); } return; }
			if (idx >= 0) { revertKey(i); beep(); alert('Key "' + key + '" is already in the database. Please try again with a new key.'); unlockEntry(i); return; }
			dataBase[i].title = key;
			writeDataBase(true);
			var entry = dataBase[i];
			eprint('replaceEntry:Saved:  ' + entry.link + itemSep + entry.title);
			saveBusy = false;
		}

		function xtn(s)
		{
    		var idx = s.lastIndexOf("."), ext;
    		if (idx >= 0)
    		{
       		 	ext = s.substring(idx);
        		if (ext.length > 8) { return ""; }
        		if (ext.length > 1) { return ext; }
    		}
    		return "";
		}

		function url_esc(s)
		{
			var ok  = "0123456789" + "abcdefghijklmnopqrstuvwxyz" + "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
				ok += "$-_.+!*'(),";
				ok += "&+/:;=?@#";
		    var del = String.fromCharCode(127);
			var hex = "0123456789ABCDEF", t = "", i, n;
			for (i = 0; i < s.length; i += 1)
			{
		        if ((" " <= s[i]) && (s[i] < del))
		        {
		        	 if (ok.indexOf(s[i]) >= 0)
		        	 {
		        	 	t += s[i];
		        	 }
		        	 else
		        	 {
		 				n = s.charCodeAt(i);
						t += "%" + hex[n >> 4] + hex[n % 16];	// change characters to %XX hex form
		        	 }
		        }
			}
			return t;
		}
		
		function makeFileURL(path)	// process file paths - leave urls unchanged
		{
			eprint('makeFileURL:path 1: "' + path + '"');
			if (((systemPlatform == "macintosh") && (path[0] == '/')) || ((systemPlatform == "windows") && (path[1] == ':')))	// we have a file path
			{
				if (preferences.convertBackSlashPref.value == "1") { path = path.replace(/\\/g, "/"); }
				if (preferences.escapeURLPref.value        == "1") { path = url_esc(path); }
				if (preferences.fileProtocolPref.value     == "1") { path = "file:///" + path; }
			}
			eprint('makeFileURL:path 2: "' + path + '"');
			return path;
		}

		function getLink()		// to choose a media file or a URL shortcut
		{
			var path = chooseFile();
			if (path === null) { return null; }

			var extn = xtn(path).toLowerCase(), data, found, lines;
			if (extn == ".webloc") {
				data = filesystem.readFile(path);
				found = data.match(lookFor1);							// <string>http://tools.ietf.org/html/rfc1738</string>
				if (found !== null) {
					eprint("Web Internet Location accepted: " + found[1]);
					return found[1];
				}
				eprint("Invalid Web Internet Location: " + data);
				return null;
			}
			else if (extn == ".url") {
				data = filesystem.readFile(path).replace(/\r\n?|\n/g, "\n");
				lines = data.split("\n");
				if (lines[0] == "[InternetShortcut]")
				{
					found = data.match(lookFor2);						// URL=http://tools.ietf.org/html/rfc1738
					if (found !== null) {
						eprint("Web site location accepted: " + found[1]);
						return found[1];
					}
					eprint("Invalid Web site location: " + data);
					return null;
				}
			}
			return makeFileURL(path);
		}

		function makePLSTEntry(link)	// called by dragDropped
		{
			if (saveBusy) { beep(); alert('Please complete the current Save operation.'); return; }
			if (!isStream(link)) { beep(); alert('Invalid url: ' + link); return; }
			if (wrongPlaylist(link)) { return; }
			var idx = -1;
			idx = findIndexOfLink(link);
			if (idx >= 0) { beep(); alert('Location "' + link + '" is already in the database. Please try again.'); return; }
			saveBusy = true;
			var key = newKeyText;
			var i = theKeys.length;
			if (i >= minEntries) { makeSpaceForEntry(); }
     		newEntry(i, key, link, "artist", "album", "category", "Automatic");
			var entry = {};
			entry.link      = link;
			entry.title     = key;
			entry.artist    = "artist";
			entry.album     = "album";
			entry.category  = "category";
			entry.mode  	= "Automatic";
			dataBase.push(entry);
			selectEntry(i);
			unlockEntry(i);
			if (i >= minEntries) { frm.end(); }
		}

		function dragDropped() {
			var path, extn, data, lines, found, url, idx, string, urls, error = ".";
			var n = system.event.data.length;
			var dropData = [];
			for (var i = 0; i < n; i += 1) { dropData[i] = system.event.data[i]; }
			
			var dropType = dropData[0];
			if (dropType == "filenames") {
				dropType = "file";
				path = dropData[1];
				extn = xtn(path).toLowerCase();
				if (extn == ".webloc") {
					data = filesystem.readFile(path);
					if (data)
					{
						found = data.match(lookFor1);	// <string>http://tools.ietf.org/html/rfc1738</string>
						if (found !== null) {
							eprint("Web Internet Location accepted: " + found[1]);
							makePLSTEntry(found[1]);
							return;
						}
						error = ". Web Internet Location file has invalid contents.";
					}
					else
					{
						idx = path.lastIndexOf("/");
						url = path.substring(idx+1);
						if (url.indexOf("http--") === 0)	// Leopard style .webloc file
						{
							idx = url.lastIndexOf(".webloc");
							url = "http://" + url.substring(6, idx).replace(/\-/g, "/");
							eprint("Web Internet Location accepted: " + url);
							makePLSTEntry(url);
							return;
						}
						error = ". Web Internet Location file is invalid.";
					}
				}
				else if (extn == ".url") {
					data = filesystem.readFile(path).replace(/\r\n?|\n/g, "\n");
					lines = data.split("\n");
					if (lines[0] == "[InternetShortcut]")
					{
						found = data.match(lookFor2);						// URL=http://tools.ietf.org/html/rfc1738
						if (found !== null) {
							eprint("Web site location accepted: " + found[1]);
							makePLSTEntry(found[1]);
							return;
						}
					}
					error = ". Web site location file has invalid contents.";
				}
				else 
				{
					path = makeFileURL(path);
					makePLSTEntry(path);
					return;
				}
			}
			else if (dropType == "string") {
				data = dropData[1];
				found = data.match(lookFor3);	// url
				if (found !== null) {
					eprint("String accepted: " + found[0]);
					makePLSTEntry(found[0]);
					return;
				}
				else { error = ". String has invalid contents."; }
			}
			else if (dropType == "urls") {
				dropType = "url";
				data = dropData[1];
				found = data.match(lookFor3);	// url
				if (found !== null) {
					eprint("Url accepted: " + found[0]);
					makePLSTEntry(found[0]);
					return;
				}
				else { error = ". Url has invalid contents."; }
			}
			beep();
			alert("Invalid " + dropType + error);
		}
		
		function newPLSTEntry()		// called by context menu item to select a new file or url shortcut
		{
			if (saveBusy) { beep(); alert('Please complete the current Save operation.'); return; }
			var link = getLink();
			if (link === null) { return; }
			if (link === "")   { return; }
			if (!isStream(link)) { beep(); alert('Invalid url: ' + link); return; }
			if (wrongPlaylist(link)) { return; }
			var idx = -1;
			idx = findIndexOfLink(link);
			if (idx >= 0) { beep(); alert('Location "' + link + '" is already in the database. Please try again.'); return; }
			saveBusy = true;
			var key = newKeyText;
			var i = theKeys.length;
			if (i >= minEntries) { makeSpaceForEntry(); }
     		newEntry(i, key, link, "artist", "album", "category", "Automatic");
			var entry = {};
			entry.link      = link;
			entry.title     = key;
			entry.artist    = "artist";
			entry.album     = "album";
			entry.category  = "category";
			entry.mode  	= "Automatic";
			dataBase.push(entry);
			selectEntry(i);
			unlockEntry(i);
			if (i >= minEntries) { frm.end(); }
			// if (frm.height + headDBHeight < midDBHeight) { reSizeAnimation(frm.height + headDBHeight, midDBHeight); }
		}

		function deleteEntry()	// called by context menu item
		{
			if (saveBusy) { beep(); alert('Please complete the current Save operation.'); return; }
			var i = this.index;
			var answer;
			if (oldSelection != i) { selectEntry(i); }
			var key = theKeys[i].data;
			var idx = findIndexOfKey(key);
			if (idx < 0) { beep(); alert('Key "' + key + '" is not in the database.'); return; }
			if (delWarning)
			{
				beep(); answer = alert('Are you sure you want to delete the entry with key "' + key +'"?', "No", "Yes");
				if (answer == 1) { return; }
			}
			var entry = dataBase.splice(idx, 1)[0];
			appendDeleted(entry);
			if (oldSelection > 0) { oldSelection -= 1; }
			writeDataBase(true);
			eprint('deleteEntry:Deleted: ' + entry.link + itemSep + entry.title);
		}

		function playEntry(i)
		{
			var entry      = dataBase[i];
			var link       = entry.link;
			var title      = entry.title;
			var artist     = entry.artist;
			var album 	   = entry.album;
			var category   = entry.category;
			var streamMode = entry.mode;
			
			var data = title;
			if (artist   != "artist")   { data += '\n' + artist; }
			if (album    != "album")    { data += '\n' + album; }
			if (category != "category") { data += '\n' + category; }
			
			Info_info.data = data;

			eprint('playEntry:entry:     ' + link + itemSep + title + itemSep + streamMode);
			
			switch (streamMode)
			{
				case "Automatic":              streamMode = "0"; break;
				case "Text Mode":              streamMode = "1"; break;
				case "QuickTime Player":       streamMode = "2"; break;
				case "RealPlayer":             streamMode = "3"; break;
				case "Windows Media Player":   streamMode = "4"; break;
				case "Application or Browser": streamMode = "5"; break;
				default:  					   streamMode = "0"; break;
			}

			switch(gDataBase)
			{
				case "SWF": gSWFIndex = i; break;
				case "XML": gXMLIndex = i; break;
			}

			showInfoWindow(true);

			// playStream(streamURL, volume, muted, paused, hidden, streamMode, linkName)
			// we normally set hidden to false here and leave it up to streams to set it appropriately

			playStream(link, gVolume, gVolumeMuted, false, false, streamMode, "None");
		}

		function playTitle()	// called by [alt-]multiClick on Title field
		{
			if (system.event.altKey) { unlockEntry(this.index); } else { playEntry(this.index); }
		}

		function editTitle()	// called by context menu item
		{
			unlockEntry(this.index);
		}
		
		function playLink()	// called by [alt-]multiClick on Artist or Album field
		{
			if (system.event.altKey) { editTheEntry(this.index); } else { playEntry(this.index); }
		}

		function editLink()	// called by context menu item
		{
			editTheLink(this.index);
		}

		function editEntry()	// called by context menu item
		{
			editTheEntry(this.index);
		}

		function editTheEntry(i)	// uses full form for manual entry of playlist items
		{
			if (saveBusy) { beep(); alert('Please complete the current Save operation.'); return; }
			if (i < 0) { return; }
			if (oldSelection != i) { selectEntry(i); }
			var key  = theKeys[i].data;
			var idx = findIndexOfKey(key);
			if (idx < 0) { beep(); alert('Key "' + key + '" is not in the database.'); return; }
			var e = dataBase[i];
			var entry = importForm(e.title, e.link, e.artist, e.album, e.category, e.mode);
			if (entry === "") { return; }	// user cancelled form
			var item = entry.split(itemSep);
			var link     = stripLeadingAndTrailingSpaces(item[0]); link = makeFileURL(link);
				key      = stripLeadingAndTrailingSpaces(item[1]);
			var artist   = stripLeadingAndTrailingSpaces(item[2]);
			var album    = stripLeadingAndTrailingSpaces(item[3]);
			var category = stripLeadingAndTrailingSpaces(item[4]);
			var mode     = stripLeadingAndTrailingSpaces(item[5]);
			if (!isStream(link)) { beep(); alert('Invalid url: ' + link); return; }
			if (wrongPlaylist(link)) { return; }
			if ( (key === "") || (key.length > maxKeyLength) ) { beep(); alert('The key is too long or too short.'); return; }
			idx = findIndexOfKey(key);
			if ((idx >= 0) && ( idx != i)) { beep(); alert('Key "' + key + '" is already in the database.'); return; }
			idx = findIndexOfLink(link);
			if ((idx >= 0) && ( idx != i)) { beep(); alert('Location "' + link + '" is already in the database.'); return; }
			entry = dataBase[i];
			appendDeleted(entry);
			eprint('editTheEntry:Deleted:' + entry.link + itemSep + entry.title);
			entry.link      = link;
			entry.title     = key;
			entry.artist    = artist;
			entry.album     = album;
			entry.category  = category;
			entry.mode  	= mode;
			writeDataBase(true);
			eprint('editTheEntry:Saved:  ' + entry.link + itemSep + entry.title);
		}

		function editTheLink(i)		// called by context menu to select a new file or url shortcut
		{
			if (saveBusy) { beep(); alert('Please complete the current Save operation.'); return; }
			if (i < 0) { return; }
			if (oldSelection != i) { selectEntry(i); }
			var key  = theKeys[i].data;
			var idx = findIndexOfKey(key);
			if (idx < 0) { beep(); alert('Key "' + key + '" is not in the database.'); return; }
			var newLink = getLink();
			if (newLink === null) { return; }	// user cancelled
			if (newLink === "")    { return; }	// nothing to do
			if (!isStream(newLink)) { beep(); alert('Invalid url: ' + newLink); return; }
			if (wrongPlaylist(newLink)) { return; }
			var idx2 = findIndexOfLink(newLink);
			if (idx2 >= 0) { beep(); alert('Location "' + newLink + '" is already in the database.'); return; }
			var entry = dataBase[i];
			appendDeleted(entry);
			eprint('editTheLink:Deleted: ' + entry.link + itemSep + entry.title);
			entry.link      = newLink;
			entry.title     = key;
			entry.artist    = "artist";
			entry.album     = "album";
			entry.category  = "category";
			entry.mode  	= "Automatic";
			writeDataBase(true);
			eprint('editTheLink:Saved:   ' + entry.link + itemSep + entry.title);
		}

		function loadDataBase(db, index)
		{
			dataBase = readDataBase(db);
    		refreshDisplay();
    		if (index === undefined) { index = -1; frm.scrollY = 0; }
    		selectEntry(index);
 			switch (db)
			{
				case "SWF": Playlist_text.data = "Flash Player Playlist";
							PLBackground.tooltip="Drag Flash files, meta-files or internet shortcuts onto me to make new entries.";
							break;
				case "XML": Playlist_text.data = "Media Player Playlist";
							PLBackground.tooltip="Drag media files, media meta-files or internet shortcuts onto me to make new entries.";
							break;
			}
		}

		function selectDataBase(db)
		{
 			var index;
 			switch (db)
			{
				case "SWF": index = gSWFIndex; break;
				case "XML": index = gXMLIndex; break;
			}
			loadDataBase(db, index);
     		main_window.visible = true;
		}

		function framePlaylist()  { selectDataBase('SWF'); }
		function playerPlaylist() { selectDataBase('XML'); }

		function frameAdd()		  { selectDataBase('SWF'); newPLSTEntry(); }
		function playerAdd()	  { selectDataBase('XML'); newPLSTEntry(); }

		function closePlaylist() { main_window.visible = false; }
		
		title.onClick  = sortByTitle;		title.tooltip  = "Sort by Title";
		artist.onClick = sortByArtist;		artist.tooltip = "Sort by Artist";
		album.onClick  = sortByAlbum;		album.tooltip  = "Sort by Album";

		focusWidget();
