//	Slider Class by Hunter Ryba and Harry Whitfield	- 20080119

function Slider(window, basePath, buttonPath, defaultValue, minValue, maxValue, x, y, action)
{
    this.minValue = minValue;
    this.maxValue = maxValue;
    this.action = action;
                
    // Create slider base
        
    this.sliderBase = new Image(window);
    this.sliderBase.src = basePath;
    this.sliderBase.hOffset = x;
    this.sliderBase.vOffset = y;
                
    // Create the slider button
        
    this.sliderButton = new Image(window);
    this.sliderButton.hAlign = "center";
    this.sliderButton.src = buttonPath;
    this.sliderButton.availLeft  = this.sliderBase.hOffset + this.sliderButton.width/2;
    this.sliderButton.availRight = this.sliderBase.hOffset + this.sliderBase.width - this.sliderButton.width/2;
    this.sliderButton.range = this.sliderButton.availRight - this.sliderButton.availLeft;
    this.sliderButton.vOffset = this.sliderBase.vOffset - (this.sliderButton.height - this.sliderBase.height)/2;
    this.sliderButton.hOffset = this.sliderButton.availLeft + this.sliderButton.range*(defaultValue - this.minValue)/(this.maxValue - this.minValue);
    this.sliderButton.onMouseDrag = this.drag;
    this.sliderButton.parent = this;
}

Slider.prototype.drag = function()  // "this" is now the sliderButton
{
    var offset = system.event.hOffset;
    if (offset < this.availLeft)       { this.hOffset = this.availLeft; }
    else if (offset > this.availRight) { this.hOffset = this.availRight; }
    else { this.hOffset = offset; }
    this.parent.action();
};

Slider.prototype.setValue = function(value)
{
    if (value < this.minValue) { value = this.minValue; }
    if (value > this.maxValue) { value = this.maxValue; }
    this.sliderButton.hOffset = this.sliderButton.availLeft + this.sliderButton.range*(value - this.minValue)/(this.maxValue - this.minValue);
    this.action();
};

Slider.prototype.getValue = function()
{
    var fraction = (this.sliderButton.hOffset - this.sliderButton.availLeft)/this.sliderButton.range;
    return fraction*(this.maxValue - this.minValue) + this.minValue;
};

//var s = null;
//function setVolume() { print(s.getValue()); }
//s = new Slider(main_window, "Resources/Controls/sliderBase.png", "Resources/Controls/sliderButton.png", 50, 0, 100, 100, 100, setVolume);
// s.setValue(33);
// print(s.getValue());
